<!DOCTYPE html>
<html lang="en">

<head>
	<title>67.S10</title>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>

	<div class="container">
		<h2 style="text-align: center;">Quản trị Voucher</h2>
		<div class="jumbotron container">
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="voucher-code">Mã Voucher</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-voucher-code" name="vouchercodes" placeholder="Voucher code"
						class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="discount">Phần trăm giảm giá</label>
				</div>
				<div class="col-sm-9">
					<input type="number" id="input-discount" name="discount" placeholder="Discount"
						class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="note">Ghi chú</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-note" name="note" placeholder="Note" class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="createDate">Ngày Tạo</label>
				</div>
				<div class="col-sm-9">
					<input type="date" id="input-createDate" name="createDate" placeholder="Create Date"
						class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="updateDate">Ngày sửa</label>
				</div>
				<div class="col-sm-9">
					<input type="date" id="input-updateDate" name="updateDate" placeholder="Update Date"
						class="form-control">
				</div>
			</div>
			<div class="row pull-right">
				<div class="col-sm-12">
					<button id="save_data" class="btn btn-info">Save Data</button>
				</div>
			</div>
		</div>
		<button id="delete_all_btn" class="btn btn-warning m-2">Delete All Data</button>

		<table class="table table-bordered table-striped table-hover" id="user-table">
			<thead>
				<tr>
					<th>STT</th>
					<th>Mã giảm giá</th>
					<th>Phần trăm giảm giá</th>
					<th>Ghi Chú</th>
					<th>Ngày tạo</th>
					<th>Ngày cập nhật</th>
					<th>Xóa</th>
				</tr>
		</table>
	</div>
</body>
<script>
	var gIdVoucher = -1;
	$(document).ready(function () {
		drawDataTable();
		$("#user-table tbody").on("click", "tr", function () {
			var rowData = table.row(this).data();
			gIdVoucher = rowData.id;
			loadVoucherToForm(gIdVoucher);
		});
		$("#save_data").on("click", function () {
			saveVoucherData();
		})
		$("#user-table tbody").on("click", ".delete-button", function () {
			gIdVoucher = $(this).data("id");
			deleteVoucher(gIdVoucher);
		});
		$("#delete_all_btn").on("click", function () {
			deleteAllVoucher();
		})
	})
	var table = $("#user-table").DataTable({
		"columns": [
			{ "data": "id" },
			{ "data": "maVoucher" },
			{ "data": "phanTramGiamGia" },
			{ "data": "ghiChu" },
			{ "data": "ngayTao" },
			{ "data": "ngayCapNhat" },
			{
				"data": null,
				"render": function (data, type, row) {
					return '<button class="btn btn-info delete-button" data-id="' + row.id + '">Xóa</button>';
				}
			}
		]
	});
	function drawDataTable() {
		$.ajax({
			url: "http://localhost:8080/api/vouchers",
			type: "GET",
			dataType: "json",
			success: function (res) {
				table.clear();
				table.rows.add(res);
				table.draw();
			},
			error: function (err) {
				console.log(err.response);
			}
		})
	}
	function loadVoucherToForm(paramgIdVoucher) {
		$.ajax({
			url: "http://localhost:8080/api/vouchers/" + paramgIdVoucher,
			type: "GET",
			dataType: "json",
			success: function (res) {
				fillDataToForm(res);
			},
			error: function (err) {
				console.log(err.response);
			}
		})
	}
	// hàm xử lí khi ấn nút save
	function saveVoucherData() {
		if (gIdVoucher == -1) {
			$.ajax({
				url: "http://localhost:8080/api/vouchers",
				type: "POST",
				contentType: "application/json",
				data: JSON.stringify({
					maVoucher: $("#input-voucher-code").val(),
					phanTramGiamGia: $("#input-discount").val(),
					ghiChu: $("#input-note").val(),
				}),
				success: function (response) {
					console.log(response);
					drawDataTable()
				},
				error: function (error) {
					console.log(err.response);
				}
			});
		}
		else {
			$.ajax({
				url: "http://localhost:8080/api/vouchers/" + gIdVoucher,
				type: "PUT",
				contentType: "application/json",
				data: JSON.stringify({
					maVoucher: $("#input-voucher-code").val(),
					phanTramGiamGia: $("#input-discount").val(),
					ghiChu: $("#input-note").val(),
				}),
				success: function (response) {
					console.log(response);
					drawDataTable()
				},
				error: function (error) {
					console.log(err.response);
				}
			});
		}
	}
	// hàm xử lí khi xóa voucher
	function deleteVoucher(paramgIdVoucher) {
		$.ajax({
			url: "http://localhost:8080/api/vouchers/" + paramgIdVoucher,
			type: "DELETE",
			dataType: "json",
			success: function (res) {
				console.log('xóa thành công');
				drawDataTable()
			},
			error: function (err) {
				console.log(err.response);
			}
		})
	}
		// hàm xử lí khi ấn nút xóa toàn bộ voucher
		function deleteAllVoucher(paramgIdVoucher) {
		$.ajax({
			url: "http://localhost:8080/api/vouchers/",
			type: "DELETE",
			dataType: "json",
			success: function (res) {
				console.log('xóa toàn bộ dữ liệu thành công');
				drawDataTable()
			},
			error: function (err) {
				console.log(err.response);
			}
		})
	}
	// hàm đỗ dữ liệu vào form
	function fillDataToForm(paramVoucher) {
		$("#input-voucher-code").val(paramVoucher.maVoucher);
		$("#input-discount").val(paramVoucher.phanTramGiamGia);
		$("#input-note").val(paramVoucher.ghiChu);
		$("#input-createDate").val(formatDateForHtml(paramVoucher.ngayTao));
		$("#input-updateDate").val(formatDateForHtml(paramVoucher.ngayCapNhat));
	}
	function formatDateForHtml(dateData) {
		if (dateData != null) {
			var dateParts = dateData.split("-");
			var formattedDate = dateParts[2] + "-" + dateParts[1] + "-" + dateParts[0];
			return formattedDate;
		}
		return;
	}
</script>

</html>